<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>VSLTypeInferenceUtil xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../apidocs/org/eclipse/papyrus/marte/vsl/extensions/VSLTypeInferenceUtil.html">View Javadoc</a></div><pre>
<a class="jxr_linenumber" name="L1" href="#L1">1</a>   <em class="jxr_javadoccomment">/*****************************************************************************</em>
<a class="jxr_linenumber" name="L2" href="#L2">2</a>   <em class="jxr_javadoccomment"> * Copyright (c) 2010, 2016 CEA LIST.</em>
<a class="jxr_linenumber" name="L3" href="#L3">3</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L4" href="#L4">4</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L5" href="#L5">5</a>   <em class="jxr_javadoccomment"> * All rights reserved. This program and the accompanying materials</em>
<a class="jxr_linenumber" name="L6" href="#L6">6</a>   <em class="jxr_javadoccomment"> * are made available under the terms of the Eclipse Public License v1.0</em>
<a class="jxr_linenumber" name="L7" href="#L7">7</a>   <em class="jxr_javadoccomment"> * which accompanies this distribution, and is available at</em>
<a class="jxr_linenumber" name="L8" href="#L8">8</a>   <em class="jxr_javadoccomment"> * <a href="http://www.eclipse.org/legal/epl-v10.htm" target="alexandria_uri">http://www.eclipse.org/legal/epl-v10.htm</a>l</em>
<a class="jxr_linenumber" name="L9" href="#L9">9</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L10" href="#L10">10</a>  <em class="jxr_javadoccomment"> * Contributors:</em>
<a class="jxr_linenumber" name="L11" href="#L11">11</a>  <em class="jxr_javadoccomment"> *  CEA LIST - Initial API and implementation</em>
<a class="jxr_linenumber" name="L12" href="#L12">12</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L13" href="#L13">13</a>  <em class="jxr_javadoccomment"> *****************************************************************************/</em>
<a class="jxr_linenumber" name="L14" href="#L14">14</a>  <strong class="jxr_keyword">package</strong> org.eclipse.papyrus.marte.vsl.extensions;
<a class="jxr_linenumber" name="L15" href="#L15">15</a>  
<a class="jxr_linenumber" name="L16" href="#L16">16</a>  <strong class="jxr_keyword">import</strong> java.util.ArrayList;
<a class="jxr_linenumber" name="L17" href="#L17">17</a>  <strong class="jxr_keyword">import</strong> java.util.List;
<a class="jxr_linenumber" name="L18" href="#L18">18</a>  
<a class="jxr_linenumber" name="L19" href="#L19">19</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.ecore.EObject;
<a class="jxr_linenumber" name="L20" href="#L20">20</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.ecore.EStructuralFeature;
<a class="jxr_linenumber" name="L21" href="#L21">21</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.marte.vsl.vSL.AdditiveExpression;
<a class="jxr_linenumber" name="L22" href="#L22">22</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.marte.vsl.vSL.AndOrXorExpression;
<a class="jxr_linenumber" name="L23" href="#L23">23</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.marte.vsl.vSL.BooleanLiteralRule;
<a class="jxr_linenumber" name="L24" href="#L24">24</a>  <em class="jxr_comment">//import org.eclipse.papyrus.marte.vsl.vSL.Choice;</em>
<a class="jxr_linenumber" name="L25" href="#L25">25</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.marte.vsl.vSL.CollectionOrTuple;
<a class="jxr_linenumber" name="L26" href="#L26">26</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.marte.vsl.vSL.ConditionalExpression;
<a class="jxr_linenumber" name="L27" href="#L27">27</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.marte.vsl.vSL.DateTimeLiteralRule;
<a class="jxr_linenumber" name="L28" href="#L28">28</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.marte.vsl.vSL.DefaultLiteralRule;
<a class="jxr_linenumber" name="L29" href="#L29">29</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.marte.vsl.vSL.DurationObsExpression;
<a class="jxr_linenumber" name="L30" href="#L30">30</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.marte.vsl.vSL.EqualityExpression;
<a class="jxr_linenumber" name="L31" href="#L31">31</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.marte.vsl.vSL.Expression;
<a class="jxr_linenumber" name="L32" href="#L32">32</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.marte.vsl.vSL.InstantObsExpression;
<a class="jxr_linenumber" name="L33" href="#L33">33</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.marte.vsl.vSL.IntegerLiteralRule;
<a class="jxr_linenumber" name="L34" href="#L34">34</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.marte.vsl.vSL.Interval;
<a class="jxr_linenumber" name="L35" href="#L35">35</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.marte.vsl.vSL.JitterExp;
<a class="jxr_linenumber" name="L36" href="#L36">36</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.marte.vsl.vSL.Literal;
<a class="jxr_linenumber" name="L37" href="#L37">37</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.marte.vsl.vSL.MultiplicativeExpression;
<a class="jxr_linenumber" name="L38" href="#L38">38</a>  <em class="jxr_comment">//import org.eclipse.papyrus.marte.vsl.vSL.Name;</em>
<a class="jxr_linenumber" name="L39" href="#L39">39</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.marte.vsl.vSL.NameOrChoiceOrBehaviorCall;
<a class="jxr_linenumber" name="L40" href="#L40">40</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.marte.vsl.vSL.NullLiteralRule;
<a class="jxr_linenumber" name="L41" href="#L41">41</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.marte.vsl.vSL.OperationCallExpression;
<a class="jxr_linenumber" name="L42" href="#L42">42</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.marte.vsl.vSL.PrimaryExpression;
<a class="jxr_linenumber" name="L43" href="#L43">43</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.marte.vsl.vSL.PropertyCallExpression;
<a class="jxr_linenumber" name="L44" href="#L44">44</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.marte.vsl.vSL.RealLiteralRule;
<a class="jxr_linenumber" name="L45" href="#L45">45</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.marte.vsl.vSL.RelationalExpression;
<a class="jxr_linenumber" name="L46" href="#L46">46</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.marte.vsl.vSL.StringLiteralRule;
<a class="jxr_linenumber" name="L47" href="#L47">47</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.marte.vsl.vSL.SuffixExpression;
<a class="jxr_linenumber" name="L48" href="#L48">48</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.marte.vsl.vSL.TimeExpression;
<a class="jxr_linenumber" name="L49" href="#L49">49</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.marte.vsl.vSL.Tuple;
<a class="jxr_linenumber" name="L50" href="#L50">50</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.marte.vsl.vSL.UnaryExpression;
<a class="jxr_linenumber" name="L51" href="#L51">51</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.marte.vsl.vSL.UnlimitedLiteralRule;
<a class="jxr_linenumber" name="L52" href="#L52">52</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.marte.vsl.vSL.ValueNamePair;
<a class="jxr_linenumber" name="L53" href="#L53">53</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.marte.vsl.vSL.ValueSpecification;
<a class="jxr_linenumber" name="L54" href="#L54">54</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.marte.vsl.vSL.VariableDeclaration;
<a class="jxr_linenumber" name="L55" href="#L55">55</a>  <em class="jxr_comment">//import org.eclipse.papyrus.marte.vsl.validation.VSLJavaValidator.ExpectedKind;</em>
<a class="jxr_linenumber" name="L56" href="#L56">56</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.marte.vsl.validation.VSLJavaValidator;
<a class="jxr_linenumber" name="L57" href="#L57">57</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Behavior;
<a class="jxr_linenumber" name="L58" href="#L58">58</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Classifier;
<a class="jxr_linenumber" name="L59" href="#L59">59</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.DataType;
<a class="jxr_linenumber" name="L60" href="#L60">60</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.EnumerationLiteral;
<a class="jxr_linenumber" name="L61" href="#L61">61</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Parameter;
<a class="jxr_linenumber" name="L62" href="#L62">62</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.ParameterDirectionKind;
<a class="jxr_linenumber" name="L63" href="#L63">63</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Property;
<a class="jxr_linenumber" name="L64" href="#L64">64</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Stereotype;
<a class="jxr_linenumber" name="L65" href="#L65">65</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Type;
<a class="jxr_linenumber" name="L66" href="#L66">66</a>  
<a class="jxr_linenumber" name="L67" href="#L67">67</a>  
<a class="jxr_linenumber" name="L68" href="#L68">68</a>  
<a class="jxr_linenumber" name="L69" href="#L69">69</a>  <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L70" href="#L70">70</a>  <em class="jxr_javadoccomment"> * @author Arnaud Cuccuru, CEA LIST, LISE</em>
<a class="jxr_linenumber" name="L71" href="#L71">71</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L72" href="#L72">72</a>  <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="L73" href="#L73">73</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../org/eclipse/papyrus/marte/vsl/extensions/VSLTypeInferenceUtil.html">VSLTypeInferenceUtil</a> {
<a class="jxr_linenumber" name="L74" href="#L74">74</a>  
<a class="jxr_linenumber" name="L75" href="#L75">75</a>  	<em class="jxr_comment">// private Namespace model ;</em>
<a class="jxr_linenumber" name="L76" href="#L76">76</a>  	<em class="jxr_comment">// private Element contextElement ;</em>
<a class="jxr_linenumber" name="L77" href="#L77">77</a>  	<strong class="jxr_keyword">private</strong> Type expectedType;
<a class="jxr_linenumber" name="L78" href="#L78">78</a>  	<em class="jxr_comment">// private ExpectedKind expectedKind ;</em>
<a class="jxr_linenumber" name="L79" href="#L79">79</a>  	<strong class="jxr_keyword">private</strong> <a href="../../../../../../org/eclipse/papyrus/marte/vsl/extensions/VSLTypeInferenceUtil.html">VSLTypeInferenceUtil</a> self;
<a class="jxr_linenumber" name="L80" href="#L80">80</a>  
<a class="jxr_linenumber" name="L81" href="#L81">81</a>  
<a class="jxr_linenumber" name="L82" href="#L82">82</a>  
<a class="jxr_linenumber" name="L83" href="#L83">83</a>  	<strong class="jxr_keyword">public</strong> <a href="../../../../../../org/eclipse/papyrus/marte/vsl/extensions/VSLTypeInferenceUtil.html">VSLTypeInferenceUtil</a>(Type expectedType) {
<a class="jxr_linenumber" name="L84" href="#L84">84</a>  		<strong class="jxr_keyword">this</strong>.expectedType = expectedType;
<a class="jxr_linenumber" name="L85" href="#L85">85</a>  		<em class="jxr_comment">// if (this.expectedType != null) { // TODO : handle the case where it is null</em>
<a class="jxr_linenumber" name="L86" href="#L86">86</a>  		<em class="jxr_comment">// if(expectedType.getAppliedStereotype("MARTE::MARTE_Annexes::VSL::DataTypes::TupleType")!=null)</em>
<a class="jxr_linenumber" name="L87" href="#L87">87</a>  		<em class="jxr_comment">// expectedKind = ExpectedKind._TUPLE ;</em>
<a class="jxr_linenumber" name="L88" href="#L88">88</a>  		<em class="jxr_comment">// else if (expectedType.getAppliedStereotype("MARTE::MARTE_Annexes::VSL::DataTypes::CollectionType")!=null)</em>
<a class="jxr_linenumber" name="L89" href="#L89">89</a>  		<em class="jxr_comment">// expectedKind = ExpectedKind._COLLECTION ;</em>
<a class="jxr_linenumber" name="L90" href="#L90">90</a>  		<em class="jxr_comment">// else if (expectedType.getAppliedStereotype("MARTE::MARTE_Annexes::VSL::DataTypes::IntervalType")!=null)</em>
<a class="jxr_linenumber" name="L91" href="#L91">91</a>  		<em class="jxr_comment">// expectedKind = ExpectedKind._INTERVAL ;</em>
<a class="jxr_linenumber" name="L92" href="#L92">92</a>  		<em class="jxr_comment">// else if (expectedType.getAppliedStereotype("MARTE::MARTE_Annexes::VSL::DataTypes::ChoiceType")!=null)</em>
<a class="jxr_linenumber" name="L93" href="#L93">93</a>  		<em class="jxr_comment">// expectedKind = ExpectedKind._CHOICE ;</em>
<a class="jxr_linenumber" name="L94" href="#L94">94</a>  		<em class="jxr_comment">// else if (expectedType instanceof Enumeration)</em>
<a class="jxr_linenumber" name="L95" href="#L95">95</a>  		<em class="jxr_comment">// expectedKind = ExpectedKind._ENUM ;</em>
<a class="jxr_linenumber" name="L96" href="#L96">96</a>  		<em class="jxr_comment">// else</em>
<a class="jxr_linenumber" name="L97" href="#L97">97</a>  		<em class="jxr_comment">// expectedKind = ExpectedKind._DATATYPE ;</em>
<a class="jxr_linenumber" name="L98" href="#L98">98</a>  		<em class="jxr_comment">// }</em>
<a class="jxr_linenumber" name="L99" href="#L99">99</a>  		self = <strong class="jxr_keyword">this</strong>;
<a class="jxr_linenumber" name="L100" href="#L100">100</a> 	}
<a class="jxr_linenumber" name="L101" href="#L101">101</a> 
<a class="jxr_linenumber" name="L102" href="#L102">102</a> 	<em class="jxr_comment">// public VSLTypeInferenceUtil(Type expectedType) {</em>
<a class="jxr_linenumber" name="L103" href="#L103">103</a> 	<em class="jxr_comment">// this(expectedType, null) ;</em>
<a class="jxr_linenumber" name="L104" href="#L104">104</a> 	<em class="jxr_comment">// }</em>
<a class="jxr_linenumber" name="L105" href="#L105">105</a> 
<a class="jxr_linenumber" name="L106" href="#L106">106</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L107" href="#L107">107</a> <em class="jxr_javadoccomment">	 * @param exp</em>
<a class="jxr_linenumber" name="L108" href="#L108">108</a> <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L109" href="#L109">109</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L110" href="#L110">110</a> 	<strong class="jxr_keyword">public</strong> Type typeOfExpression(Expression exp) {
<a class="jxr_linenumber" name="L111" href="#L111">111</a> 		<em class="jxr_comment">// Type oldGloballyExpectedType = VSLJavaValidator.expectedType ;</em>
<a class="jxr_linenumber" name="L112" href="#L112">112</a> 		<em class="jxr_comment">// ExpectedKind oldGloballyExpectedKind = VSLJavaValidator.expectedKind ;</em>
<a class="jxr_linenumber" name="L113" href="#L113">113</a> 		<em class="jxr_comment">// VSLJavaValidator.expectedKind = expectedKind ;</em>
<a class="jxr_linenumber" name="L114" href="#L114">114</a> 		<em class="jxr_comment">// VSLJavaValidator.expectedType = expectedType ;</em>
<a class="jxr_linenumber" name="L115" href="#L115">115</a> 		Type inferedType = typeOfAndOrXorExpression(exp.getExp());
<a class="jxr_linenumber" name="L116" href="#L116">116</a> 		<em class="jxr_comment">// VSLJavaValidator.expectedType = oldGloballyExpectedType ;</em>
<a class="jxr_linenumber" name="L117" href="#L117">117</a> 		<em class="jxr_comment">// VSLJavaValidator.expectedKind = oldGloballyExpectedKind ;</em>
<a class="jxr_linenumber" name="L118" href="#L118">118</a> 		<strong class="jxr_keyword">return</strong> inferedType;
<a class="jxr_linenumber" name="L119" href="#L119">119</a> 	}
<a class="jxr_linenumber" name="L120" href="#L120">120</a> 
<a class="jxr_linenumber" name="L121" href="#L121">121</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L122" href="#L122">122</a> <em class="jxr_javadoccomment">	 * @param exp</em>
<a class="jxr_linenumber" name="L123" href="#L123">123</a> <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L124" href="#L124">124</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L125" href="#L125">125</a> 	<strong class="jxr_keyword">private</strong> Type typeOfAndOrXorExpression(AndOrXorExpression exp) {
<a class="jxr_linenumber" name="L126" href="#L126">126</a> 		<strong class="jxr_keyword">if</strong> (exp.getExp().size() &gt; 1) {
<a class="jxr_linenumber" name="L127" href="#L127">127</a> 			Type firstOperandType = typeOfEqualityExpression(exp.getExp().get(0));
<a class="jxr_linenumber" name="L128" href="#L128">128</a> 			Type secondOperandType;
<a class="jxr_linenumber" name="L129" href="#L129">129</a> 			<strong class="jxr_keyword">for</strong> (<strong class="jxr_keyword">int</strong> i = 1; i &lt; exp.getExp().size(); i++) {
<a class="jxr_linenumber" name="L130" href="#L130">130</a> 				secondOperandType = typeOfEqualityExpression(exp.getExp().get(i));
<a class="jxr_linenumber" name="L131" href="#L131">131</a> 				firstOperandType = VSLJavaValidator.opSignatures.get(
<a class="jxr_linenumber" name="L132" href="#L132">132</a> 						exp.getOp().get(i - 1) + <span class="jxr_string">"("</span> +
<a class="jxr_linenumber" name="L133" href="#L133">133</a> 								(firstOperandType != <strong class="jxr_keyword">null</strong> ? firstOperandType.getName() : <span class="jxr_string">"null"</span>) + <span class="jxr_string">","</span> +
<a class="jxr_linenumber" name="L134" href="#L134">134</a> 								(secondOperandType != <strong class="jxr_keyword">null</strong> ? secondOperandType.getName() : <span class="jxr_string">"null"</span>) + <span class="jxr_string">")"</span>);
<a class="jxr_linenumber" name="L135" href="#L135">135</a> 			}
<a class="jxr_linenumber" name="L136" href="#L136">136</a> 			<strong class="jxr_keyword">return</strong> firstOperandType;
<a class="jxr_linenumber" name="L137" href="#L137">137</a> 		}
<a class="jxr_linenumber" name="L138" href="#L138">138</a> 		<strong class="jxr_keyword">return</strong> typeOfEqualityExpression(exp.getExp().get(0));
<a class="jxr_linenumber" name="L139" href="#L139">139</a> 	}
<a class="jxr_linenumber" name="L140" href="#L140">140</a> 
<a class="jxr_linenumber" name="L141" href="#L141">141</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L142" href="#L142">142</a> <em class="jxr_javadoccomment">	 * @param exp</em>
<a class="jxr_linenumber" name="L143" href="#L143">143</a> <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L144" href="#L144">144</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L145" href="#L145">145</a> 	<strong class="jxr_keyword">private</strong> Type typeOfEqualityExpression(EqualityExpression exp) {
<a class="jxr_linenumber" name="L146" href="#L146">146</a> 		<strong class="jxr_keyword">if</strong> (exp.getExp().size() &gt; 1) {
<a class="jxr_linenumber" name="L147" href="#L147">147</a> 			Type firstOperandType = typeOfRelationalExpression(exp.getExp().get(0));
<a class="jxr_linenumber" name="L148" href="#L148">148</a> 			Type secondOperandType;
<a class="jxr_linenumber" name="L149" href="#L149">149</a> 			<strong class="jxr_keyword">for</strong> (<strong class="jxr_keyword">int</strong> i = 1; i &lt; exp.getExp().size(); i++) {
<a class="jxr_linenumber" name="L150" href="#L150">150</a> 				secondOperandType = typeOfRelationalExpression(exp.getExp().get(i));
<a class="jxr_linenumber" name="L151" href="#L151">151</a> 				firstOperandType = VSLJavaValidator.opSignatures.get(
<a class="jxr_linenumber" name="L152" href="#L152">152</a> 						exp.getOp().get(i - 1) + <span class="jxr_string">"("</span> +
<a class="jxr_linenumber" name="L153" href="#L153">153</a> 								(firstOperandType != <strong class="jxr_keyword">null</strong> ? firstOperandType.getName() : <span class="jxr_string">"null"</span>) + <span class="jxr_string">","</span> +
<a class="jxr_linenumber" name="L154" href="#L154">154</a> 								(secondOperandType != <strong class="jxr_keyword">null</strong> ? secondOperandType.getName() : <span class="jxr_string">"null"</span>) + <span class="jxr_string">")"</span>);
<a class="jxr_linenumber" name="L155" href="#L155">155</a> 			}
<a class="jxr_linenumber" name="L156" href="#L156">156</a> 			<strong class="jxr_keyword">return</strong> firstOperandType;
<a class="jxr_linenumber" name="L157" href="#L157">157</a> 		}
<a class="jxr_linenumber" name="L158" href="#L158">158</a> 		<strong class="jxr_keyword">return</strong> typeOfRelationalExpression(exp.getExp().get(0));
<a class="jxr_linenumber" name="L159" href="#L159">159</a> 	}
<a class="jxr_linenumber" name="L160" href="#L160">160</a> 
<a class="jxr_linenumber" name="L161" href="#L161">161</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L162" href="#L162">162</a> <em class="jxr_javadoccomment">	 * @param exp</em>
<a class="jxr_linenumber" name="L163" href="#L163">163</a> <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L164" href="#L164">164</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L165" href="#L165">165</a> 	<strong class="jxr_keyword">private</strong> Type typeOfRelationalExpression(RelationalExpression exp) {
<a class="jxr_linenumber" name="L166" href="#L166">166</a> 		<strong class="jxr_keyword">if</strong> (exp.getExp().size() &gt; 1) {
<a class="jxr_linenumber" name="L167" href="#L167">167</a> 			Type firstOperandType = typeOfConditionalExpression(exp.getExp().get(0));
<a class="jxr_linenumber" name="L168" href="#L168">168</a> 			Type secondOperandType;
<a class="jxr_linenumber" name="L169" href="#L169">169</a> 			<strong class="jxr_keyword">for</strong> (<strong class="jxr_keyword">int</strong> i = 1; i &lt; exp.getExp().size(); i++) {
<a class="jxr_linenumber" name="L170" href="#L170">170</a> 				secondOperandType = typeOfConditionalExpression(exp.getExp().get(i));
<a class="jxr_linenumber" name="L171" href="#L171">171</a> 				firstOperandType = VSLJavaValidator.opSignatures.get(
<a class="jxr_linenumber" name="L172" href="#L172">172</a> 						exp.getOp().get(i - 1) + <span class="jxr_string">"("</span> +
<a class="jxr_linenumber" name="L173" href="#L173">173</a> 								(firstOperandType != <strong class="jxr_keyword">null</strong> ? firstOperandType.getName() : <span class="jxr_string">"null"</span>) + <span class="jxr_string">","</span> +
<a class="jxr_linenumber" name="L174" href="#L174">174</a> 								(secondOperandType != <strong class="jxr_keyword">null</strong> ? secondOperandType.getName() : <span class="jxr_string">"null"</span>) + <span class="jxr_string">")"</span>);
<a class="jxr_linenumber" name="L175" href="#L175">175</a> 			}
<a class="jxr_linenumber" name="L176" href="#L176">176</a> 			<strong class="jxr_keyword">return</strong> firstOperandType;
<a class="jxr_linenumber" name="L177" href="#L177">177</a> 		}
<a class="jxr_linenumber" name="L178" href="#L178">178</a> 		<strong class="jxr_keyword">return</strong> typeOfConditionalExpression(exp.getExp().get(0));
<a class="jxr_linenumber" name="L179" href="#L179">179</a> 	}
<a class="jxr_linenumber" name="L180" href="#L180">180</a> 
<a class="jxr_linenumber" name="L181" href="#L181">181</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L182" href="#L182">182</a> <em class="jxr_javadoccomment">	 * @param exp</em>
<a class="jxr_linenumber" name="L183" href="#L183">183</a> <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L184" href="#L184">184</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L185" href="#L185">185</a> 	<strong class="jxr_keyword">private</strong> Type typeOfConditionalExpression(ConditionalExpression exp) {
<a class="jxr_linenumber" name="L186" href="#L186">186</a> 		Classifier thenOperandType;
<a class="jxr_linenumber" name="L187" href="#L187">187</a> 		Classifier elseOperandType;
<a class="jxr_linenumber" name="L188" href="#L188">188</a> 		<strong class="jxr_keyword">if</strong> (exp.getExp().size() == 3) {
<a class="jxr_linenumber" name="L189" href="#L189">189</a> 			thenOperandType = (exp.getExp().get(1) != <strong class="jxr_keyword">null</strong>) ? (Classifier) typeOfAdditiveExpression(exp.getExp().get(1)) : <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L190" href="#L190">190</a> 			elseOperandType = (exp.getExp().get(2) != <strong class="jxr_keyword">null</strong>) ? (Classifier) typeOfAdditiveExpression(exp.getExp().get(2)) : <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L191" href="#L191">191</a> 			<strong class="jxr_keyword">if</strong> (thenOperandType == elseOperandType) {
<a class="jxr_linenumber" name="L192" href="#L192">192</a> 				<strong class="jxr_keyword">return</strong> thenOperandType;
<a class="jxr_linenumber" name="L193" href="#L193">193</a> 			} <strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (thenOperandType != <strong class="jxr_keyword">null</strong> &amp;&amp; areTypesCompatible(thenOperandType, elseOperandType)) {
<a class="jxr_linenumber" name="L194" href="#L194">194</a> 				<strong class="jxr_keyword">return</strong> elseOperandType;
<a class="jxr_linenumber" name="L195" href="#L195">195</a> 			} <strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (elseOperandType != <strong class="jxr_keyword">null</strong> &amp;&amp; areTypesCompatible(elseOperandType, thenOperandType)) {
<a class="jxr_linenumber" name="L196" href="#L196">196</a> 				<strong class="jxr_keyword">return</strong> thenOperandType;
<a class="jxr_linenumber" name="L197" href="#L197">197</a> 			} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L198" href="#L198">198</a> 				<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L199" href="#L199">199</a> 			}
<a class="jxr_linenumber" name="L200" href="#L200">200</a> 		}
<a class="jxr_linenumber" name="L201" href="#L201">201</a> 		<strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (exp.getExp().size() == 2) {
<a class="jxr_linenumber" name="L202" href="#L202">202</a> 			<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L203" href="#L203">203</a> 		} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L204" href="#L204">204</a> 			<strong class="jxr_keyword">return</strong> typeOfAdditiveExpression(exp.getExp().get(0));
<a class="jxr_linenumber" name="L205" href="#L205">205</a> 		}
<a class="jxr_linenumber" name="L206" href="#L206">206</a> 	}
<a class="jxr_linenumber" name="L207" href="#L207">207</a> 
<a class="jxr_linenumber" name="L208" href="#L208">208</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L209" href="#L209">209</a> <em class="jxr_javadoccomment">	 * @param exp</em>
<a class="jxr_linenumber" name="L210" href="#L210">210</a> <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L211" href="#L211">211</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L212" href="#L212">212</a> 	<strong class="jxr_keyword">public</strong> Type typeOfAdditiveExpression(AdditiveExpression exp) {
<a class="jxr_linenumber" name="L213" href="#L213">213</a> 		<strong class="jxr_keyword">if</strong> (exp.getExp().size() &gt; 1) {
<a class="jxr_linenumber" name="L214" href="#L214">214</a> 			Type firstOperandType = typeOfMultiplicativeExpression(exp.getExp().get(0));
<a class="jxr_linenumber" name="L215" href="#L215">215</a> 			Type secondOperandType;
<a class="jxr_linenumber" name="L216" href="#L216">216</a> 			<strong class="jxr_keyword">for</strong> (<strong class="jxr_keyword">int</strong> i = 1; i &lt; exp.getExp().size(); i++) {
<a class="jxr_linenumber" name="L217" href="#L217">217</a> 				secondOperandType = typeOfMultiplicativeExpression(exp.getExp().get(i));
<a class="jxr_linenumber" name="L218" href="#L218">218</a> 				firstOperandType = VSLJavaValidator.opSignatures.get(
<a class="jxr_linenumber" name="L219" href="#L219">219</a> 						exp.getOp().get(i - 1) + <span class="jxr_string">"("</span> +
<a class="jxr_linenumber" name="L220" href="#L220">220</a> 								(firstOperandType != <strong class="jxr_keyword">null</strong> ? firstOperandType.getName() : <span class="jxr_string">"null"</span>) + <span class="jxr_string">","</span> +
<a class="jxr_linenumber" name="L221" href="#L221">221</a> 								(secondOperandType != <strong class="jxr_keyword">null</strong> ? secondOperandType.getName() : <span class="jxr_string">"null"</span>) + <span class="jxr_string">")"</span>);
<a class="jxr_linenumber" name="L222" href="#L222">222</a> 			}
<a class="jxr_linenumber" name="L223" href="#L223">223</a> 			<strong class="jxr_keyword">return</strong> firstOperandType;
<a class="jxr_linenumber" name="L224" href="#L224">224</a> 		}
<a class="jxr_linenumber" name="L225" href="#L225">225</a> 		<strong class="jxr_keyword">return</strong> typeOfMultiplicativeExpression(exp.getExp().get(0));
<a class="jxr_linenumber" name="L226" href="#L226">226</a> 	}
<a class="jxr_linenumber" name="L227" href="#L227">227</a> 
<a class="jxr_linenumber" name="L228" href="#L228">228</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L229" href="#L229">229</a> <em class="jxr_javadoccomment">	 * @param exp</em>
<a class="jxr_linenumber" name="L230" href="#L230">230</a> <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L231" href="#L231">231</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L232" href="#L232">232</a> 	<strong class="jxr_keyword">private</strong> Type typeOfMultiplicativeExpression(MultiplicativeExpression exp) {
<a class="jxr_linenumber" name="L233" href="#L233">233</a> 		<strong class="jxr_keyword">if</strong> (exp.getExp().size() &gt; 1) {
<a class="jxr_linenumber" name="L234" href="#L234">234</a> 			Type firstOperandType = typeOfUnaryExpression(exp.getExp().get(0));
<a class="jxr_linenumber" name="L235" href="#L235">235</a> 			Type secondOperandType;
<a class="jxr_linenumber" name="L236" href="#L236">236</a> 			<strong class="jxr_keyword">for</strong> (<strong class="jxr_keyword">int</strong> i = 1; i &lt; exp.getExp().size(); i++) {
<a class="jxr_linenumber" name="L237" href="#L237">237</a> 				secondOperandType = typeOfUnaryExpression(exp.getExp().get(i));
<a class="jxr_linenumber" name="L238" href="#L238">238</a> 				firstOperandType = VSLJavaValidator.opSignatures.get(
<a class="jxr_linenumber" name="L239" href="#L239">239</a> 						exp.getOp().get(i - 1) + <span class="jxr_string">"("</span> +
<a class="jxr_linenumber" name="L240" href="#L240">240</a> 								(firstOperandType != <strong class="jxr_keyword">null</strong> ? firstOperandType.getName() : <span class="jxr_string">"null"</span>) + <span class="jxr_string">","</span> +
<a class="jxr_linenumber" name="L241" href="#L241">241</a> 								(secondOperandType != <strong class="jxr_keyword">null</strong> ? secondOperandType.getName() : <span class="jxr_string">"null"</span>) + <span class="jxr_string">")"</span>);
<a class="jxr_linenumber" name="L242" href="#L242">242</a> 			}
<a class="jxr_linenumber" name="L243" href="#L243">243</a> 			<strong class="jxr_keyword">return</strong> firstOperandType;
<a class="jxr_linenumber" name="L244" href="#L244">244</a> 		}
<a class="jxr_linenumber" name="L245" href="#L245">245</a> 		<strong class="jxr_keyword">return</strong> exp.getExp().size() &gt; 0 ? typeOfUnaryExpression(exp.getExp().get(0)) : <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L246" href="#L246">246</a> 	}
<a class="jxr_linenumber" name="L247" href="#L247">247</a> 
<a class="jxr_linenumber" name="L248" href="#L248">248</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L249" href="#L249">249</a> <em class="jxr_javadoccomment">	 * @param exp</em>
<a class="jxr_linenumber" name="L250" href="#L250">250</a> <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L251" href="#L251">251</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L252" href="#L252">252</a> 	<strong class="jxr_keyword">private</strong> Type typeOfUnaryExpression(UnaryExpression exp) {
<a class="jxr_linenumber" name="L253" href="#L253">253</a> 		<strong class="jxr_keyword">if</strong> (exp.getOp() != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L254" href="#L254">254</a> 			Type typeOfUnary = typeOfUnaryExpression(exp.getUnary());
<a class="jxr_linenumber" name="L255" href="#L255">255</a> 			<strong class="jxr_keyword">return</strong> VSLJavaValidator.opSignatures.get(exp.getOp() + <span class="jxr_string">"("</span> +
<a class="jxr_linenumber" name="L256" href="#L256">256</a> 					(typeOfUnary != <strong class="jxr_keyword">null</strong> ? typeOfUnary.getName() : <span class="jxr_string">"null"</span>)
<a class="jxr_linenumber" name="L257" href="#L257">257</a> 					+ <span class="jxr_string">")"</span>);
<a class="jxr_linenumber" name="L258" href="#L258">258</a> 		}
<a class="jxr_linenumber" name="L259" href="#L259">259</a> 		<strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (exp.getExp() != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L260" href="#L260">260</a> 			<strong class="jxr_keyword">return</strong> typeOfPrimaryExpression(exp.getExp());
<a class="jxr_linenumber" name="L261" href="#L261">261</a> 		} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L262" href="#L262">262</a> 			<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L263" href="#L263">263</a> 		}
<a class="jxr_linenumber" name="L264" href="#L264">264</a> 	}
<a class="jxr_linenumber" name="L265" href="#L265">265</a> 
<a class="jxr_linenumber" name="L266" href="#L266">266</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L267" href="#L267">267</a> <em class="jxr_javadoccomment">	 * @param exp</em>
<a class="jxr_linenumber" name="L268" href="#L268">268</a> <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L269" href="#L269">269</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L270" href="#L270">270</a> 	<strong class="jxr_keyword">private</strong> Type typeOfPrimaryExpression(PrimaryExpression exp) {
<a class="jxr_linenumber" name="L271" href="#L271">271</a> 		<strong class="jxr_keyword">if</strong> (exp.getSuffix() != <strong class="jxr_keyword">null</strong>) { <em class="jxr_comment">// &amp;&amp; exp.getSuffix() != suffixExpressionToIgnore) {</em>
<a class="jxr_linenumber" name="L272" href="#L272">272</a> 			<strong class="jxr_keyword">return</strong> typeOfSuffixPression(exp.getSuffix());
<a class="jxr_linenumber" name="L273" href="#L273">273</a> 		}
<a class="jxr_linenumber" name="L274" href="#L274">274</a> 		<strong class="jxr_keyword">return</strong> typeOfValueSpecification(exp.getPrefix());
<a class="jxr_linenumber" name="L275" href="#L275">275</a> 	}
<a class="jxr_linenumber" name="L276" href="#L276">276</a> 
<a class="jxr_linenumber" name="L277" href="#L277">277</a> 	<strong class="jxr_keyword">private</strong> Type typeOfSuffixPression(SuffixExpression exp) {
<a class="jxr_linenumber" name="L278" href="#L278">278</a> 		<strong class="jxr_keyword">if</strong> (exp instanceof OperationCallExpression) {
<a class="jxr_linenumber" name="L279" href="#L279">279</a> 			<strong class="jxr_keyword">return</strong> typeOfOperationCallExpression((OperationCallExpression) exp);
<a class="jxr_linenumber" name="L280" href="#L280">280</a> 		}
<a class="jxr_linenumber" name="L281" href="#L281">281</a> 		<strong class="jxr_keyword">else</strong> { <em class="jxr_comment">// PropertyCallExpression</em>
<a class="jxr_linenumber" name="L282" href="#L282">282</a> 			<strong class="jxr_keyword">return</strong> typeOfPropertyCallExpression((PropertyCallExpression) exp);
<a class="jxr_linenumber" name="L283" href="#L283">283</a> 		}
<a class="jxr_linenumber" name="L284" href="#L284">284</a> 	}
<a class="jxr_linenumber" name="L285" href="#L285">285</a> 
<a class="jxr_linenumber" name="L286" href="#L286">286</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L287" href="#L287">287</a> <em class="jxr_javadoccomment">	 * @param exp</em>
<a class="jxr_linenumber" name="L288" href="#L288">288</a> <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L289" href="#L289">289</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L290" href="#L290">290</a> 	<strong class="jxr_keyword">private</strong> Type typeOfOperationCallExpression(OperationCallExpression exp) {
<a class="jxr_linenumber" name="L291" href="#L291">291</a> 		<strong class="jxr_keyword">if</strong> (exp.getSuffix() != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L292" href="#L292">292</a> 			<strong class="jxr_keyword">return</strong> typeOfSuffixPression(exp.getSuffix());
<a class="jxr_linenumber" name="L293" href="#L293">293</a> 		}
<a class="jxr_linenumber" name="L294" href="#L294">294</a> 		<strong class="jxr_keyword">return</strong> exp.getOperation() != <strong class="jxr_keyword">null</strong> ? exp.getOperation().getType() : <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L295" href="#L295">295</a> 	}
<a class="jxr_linenumber" name="L296" href="#L296">296</a> 
<a class="jxr_linenumber" name="L297" href="#L297">297</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L298" href="#L298">298</a> <em class="jxr_javadoccomment">	 * @param exp</em>
<a class="jxr_linenumber" name="L299" href="#L299">299</a> <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L300" href="#L300">300</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L301" href="#L301">301</a> 	<strong class="jxr_keyword">private</strong> Type typeOfPropertyCallExpression(PropertyCallExpression exp) {
<a class="jxr_linenumber" name="L302" href="#L302">302</a> 		<strong class="jxr_keyword">if</strong> (exp.getSuffix() != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L303" href="#L303">303</a> 			<strong class="jxr_keyword">return</strong> typeOfSuffixPression(exp.getSuffix());
<a class="jxr_linenumber" name="L304" href="#L304">304</a> 		}
<a class="jxr_linenumber" name="L305" href="#L305">305</a> 		<strong class="jxr_keyword">return</strong> exp.getProperty() != <strong class="jxr_keyword">null</strong> ? exp.getProperty().getType() : <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L306" href="#L306">306</a> 	}
<a class="jxr_linenumber" name="L307" href="#L307">307</a> 
<a class="jxr_linenumber" name="L308" href="#L308">308</a> 
<a class="jxr_linenumber" name="L309" href="#L309">309</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L310" href="#L310">310</a> <em class="jxr_javadoccomment">	 * @param value</em>
<a class="jxr_linenumber" name="L311" href="#L311">311</a> <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L312" href="#L312">312</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L313" href="#L313">313</a> 	<strong class="jxr_keyword">public</strong> Type typeOfValueSpecification(ValueSpecification value) {
<a class="jxr_linenumber" name="L314" href="#L314">314</a> 
<a class="jxr_linenumber" name="L315" href="#L315">315</a> 		<strong class="jxr_keyword">if</strong> (value instanceof Literal) {
<a class="jxr_linenumber" name="L316" href="#L316">316</a> 			<strong class="jxr_keyword">return</strong> typeOfLiteral((Literal) value);
<a class="jxr_linenumber" name="L317" href="#L317">317</a> 		}
<a class="jxr_linenumber" name="L318" href="#L318">318</a> 		<strong class="jxr_keyword">if</strong> (value instanceof NameOrChoiceOrBehaviorCall) {
<a class="jxr_linenumber" name="L319" href="#L319">319</a> 			<strong class="jxr_keyword">return</strong> typeOfNameOrChoiceOrBehaviorCall((NameOrChoiceOrBehaviorCall) value);
<a class="jxr_linenumber" name="L320" href="#L320">320</a> 		}
<a class="jxr_linenumber" name="L321" href="#L321">321</a> 		<strong class="jxr_keyword">if</strong> (value instanceof TimeExpression) {
<a class="jxr_linenumber" name="L322" href="#L322">322</a> 			<strong class="jxr_keyword">return</strong> typeOfTimeExpression((TimeExpression) value);
<a class="jxr_linenumber" name="L323" href="#L323">323</a> 		}
<a class="jxr_linenumber" name="L324" href="#L324">324</a> 		<strong class="jxr_keyword">if</strong> (value instanceof VariableDeclaration) {
<a class="jxr_linenumber" name="L325" href="#L325">325</a> 			<strong class="jxr_keyword">return</strong> typeOfVariableDeclaration((VariableDeclaration) value);
<a class="jxr_linenumber" name="L326" href="#L326">326</a> 		}
<a class="jxr_linenumber" name="L327" href="#L327">327</a> 		<strong class="jxr_keyword">if</strong> (value instanceof Expression) {
<a class="jxr_linenumber" name="L328" href="#L328">328</a> 			<strong class="jxr_keyword">return</strong> typeOfExpression((Expression) value);
<a class="jxr_linenumber" name="L329" href="#L329">329</a> 		}
<a class="jxr_linenumber" name="L330" href="#L330">330</a> 		<em class="jxr_comment">// if (value instanceof Choice) {</em>
<a class="jxr_linenumber" name="L331" href="#L331">331</a> 		<em class="jxr_comment">// return typeOfChoice ((Choice)value) ;</em>
<a class="jxr_linenumber" name="L332" href="#L332">332</a> 		<em class="jxr_comment">// }</em>
<a class="jxr_linenumber" name="L333" href="#L333">333</a> 		<strong class="jxr_keyword">if</strong> (value instanceof Interval) {
<a class="jxr_linenumber" name="L334" href="#L334">334</a> 			<strong class="jxr_keyword">return</strong> typeOfInterval((Interval) value);
<a class="jxr_linenumber" name="L335" href="#L335">335</a> 		}
<a class="jxr_linenumber" name="L336" href="#L336">336</a> 		<strong class="jxr_keyword">if</strong> (value instanceof Tuple) {
<a class="jxr_linenumber" name="L337" href="#L337">337</a> 			<strong class="jxr_keyword">return</strong> typeOfTuple((Tuple) value);
<a class="jxr_linenumber" name="L338" href="#L338">338</a> 		}
<a class="jxr_linenumber" name="L339" href="#L339">339</a> 		<strong class="jxr_keyword">if</strong> (value instanceof CollectionOrTuple) {
<a class="jxr_linenumber" name="L340" href="#L340">340</a> 			<strong class="jxr_keyword">return</strong> typeOfCollectionOrTuple((CollectionOrTuple) value);
<a class="jxr_linenumber" name="L341" href="#L341">341</a> 		}
<a class="jxr_linenumber" name="L342" href="#L342">342</a> 
<a class="jxr_linenumber" name="L343" href="#L343">343</a> 		<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L344" href="#L344">344</a> 	}
<a class="jxr_linenumber" name="L345" href="#L345">345</a> 
<a class="jxr_linenumber" name="L346" href="#L346">346</a> 
<a class="jxr_linenumber" name="L347" href="#L347">347</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L348" href="#L348">348</a> <em class="jxr_javadoccomment">	 * @param literal</em>
<a class="jxr_linenumber" name="L349" href="#L349">349</a> <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L350" href="#L350">350</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L351" href="#L351">351</a> 	<strong class="jxr_keyword">private</strong> Type typeOfLiteral(Literal literal) {
<a class="jxr_linenumber" name="L352" href="#L352">352</a> 		<strong class="jxr_keyword">if</strong> (literal instanceof IntegerLiteralRule) {
<a class="jxr_linenumber" name="L353" href="#L353">353</a> 			<strong class="jxr_keyword">return</strong> VSLJavaValidator._integer;
<a class="jxr_linenumber" name="L354" href="#L354">354</a> 		}
<a class="jxr_linenumber" name="L355" href="#L355">355</a> 		<strong class="jxr_keyword">if</strong> (literal instanceof UnlimitedLiteralRule) {
<a class="jxr_linenumber" name="L356" href="#L356">356</a> 			<strong class="jxr_keyword">return</strong> VSLJavaValidator._unlimitedNatural;
<a class="jxr_linenumber" name="L357" href="#L357">357</a> 		}
<a class="jxr_linenumber" name="L358" href="#L358">358</a> 		<strong class="jxr_keyword">if</strong> (literal instanceof RealLiteralRule) {
<a class="jxr_linenumber" name="L359" href="#L359">359</a> 			<strong class="jxr_keyword">return</strong> VSLJavaValidator._real;
<a class="jxr_linenumber" name="L360" href="#L360">360</a> 		}
<a class="jxr_linenumber" name="L361" href="#L361">361</a> 		<strong class="jxr_keyword">if</strong> (literal instanceof DateTimeLiteralRule) {
<a class="jxr_linenumber" name="L362" href="#L362">362</a> 			<strong class="jxr_keyword">return</strong> VSLJavaValidator._datetime;
<a class="jxr_linenumber" name="L363" href="#L363">363</a> 		}
<a class="jxr_linenumber" name="L364" href="#L364">364</a> 		<strong class="jxr_keyword">if</strong> (literal instanceof BooleanLiteralRule) {
<a class="jxr_linenumber" name="L365" href="#L365">365</a> 			<strong class="jxr_keyword">return</strong> VSLJavaValidator._<strong class="jxr_keyword">boolean</strong>;
<a class="jxr_linenumber" name="L366" href="#L366">366</a> 		}
<a class="jxr_linenumber" name="L367" href="#L367">367</a> 		<strong class="jxr_keyword">if</strong> (literal instanceof NullLiteralRule) {
<a class="jxr_linenumber" name="L368" href="#L368">368</a> 			Type locallyExpected = VSLContextUtil.getExpectedType(literal);
<a class="jxr_linenumber" name="L369" href="#L369">369</a> 			<em class="jxr_comment">// return expectedType ;</em>
<a class="jxr_linenumber" name="L370" href="#L370">370</a> 			<strong class="jxr_keyword">return</strong> locallyExpected;
<a class="jxr_linenumber" name="L371" href="#L371">371</a> 		}
<a class="jxr_linenumber" name="L372" href="#L372">372</a> 		<strong class="jxr_keyword">if</strong> (literal instanceof DefaultLiteralRule) {
<a class="jxr_linenumber" name="L373" href="#L373">373</a> 			Type locallyExpected = VSLContextUtil.getExpectedType(literal);
<a class="jxr_linenumber" name="L374" href="#L374">374</a> 			<em class="jxr_comment">// return expectedType ;</em>
<a class="jxr_linenumber" name="L375" href="#L375">375</a> 			<strong class="jxr_keyword">return</strong> locallyExpected;
<a class="jxr_linenumber" name="L376" href="#L376">376</a> 		}
<a class="jxr_linenumber" name="L377" href="#L377">377</a> 		<strong class="jxr_keyword">if</strong> (literal instanceof StringLiteralRule) {
<a class="jxr_linenumber" name="L378" href="#L378">378</a> 			<strong class="jxr_keyword">return</strong> VSLJavaValidator._string;
<a class="jxr_linenumber" name="L379" href="#L379">379</a> 		}
<a class="jxr_linenumber" name="L380" href="#L380">380</a> 		<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L381" href="#L381">381</a> 	}
<a class="jxr_linenumber" name="L382" href="#L382">382</a> 
<a class="jxr_linenumber" name="L383" href="#L383">383</a> 
<a class="jxr_linenumber" name="L384" href="#L384">384</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L385" href="#L385">385</a> <em class="jxr_javadoccomment">	 * @param name</em>
<a class="jxr_linenumber" name="L386" href="#L386">386</a> <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L387" href="#L387">387</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L388" href="#L388">388</a> 	<strong class="jxr_keyword">private</strong> Type typeOfNameOrChoiceOrBehaviorCall(NameOrChoiceOrBehaviorCall name) {
<a class="jxr_linenumber" name="L389" href="#L389">389</a> 		<strong class="jxr_keyword">if</strong> (name.getId() != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L390" href="#L390">390</a> 			<strong class="jxr_keyword">if</strong> (name.getId() instanceof EnumerationLiteral) {
<a class="jxr_linenumber" name="L391" href="#L391">391</a> 				<strong class="jxr_keyword">return</strong> ((EnumerationLiteral) name.getId()).getEnumeration();
<a class="jxr_linenumber" name="L392" href="#L392">392</a> 			}
<a class="jxr_linenumber" name="L393" href="#L393">393</a> 			<strong class="jxr_keyword">if</strong> (name.getId() instanceof Property) {
<a class="jxr_linenumber" name="L394" href="#L394">394</a> 				<strong class="jxr_keyword">if</strong> (name.getId().getNamespace().getAppliedStereotype(<span class="jxr_string">"MARTE::MARTE_Annexes::VSL::DataTypes::ChoiceType"</span>) != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L395" href="#L395">395</a> 					<strong class="jxr_keyword">return</strong> (Type) name.getId().getNamespace();
<a class="jxr_linenumber" name="L396" href="#L396">396</a> 				}
<a class="jxr_linenumber" name="L397" href="#L397">397</a> 				<strong class="jxr_keyword">return</strong> ((Property) name.getId()).getType();
<a class="jxr_linenumber" name="L398" href="#L398">398</a> 			}
<a class="jxr_linenumber" name="L399" href="#L399">399</a> 			<strong class="jxr_keyword">if</strong> (name.getId() instanceof Behavior) {
<a class="jxr_linenumber" name="L400" href="#L400">400</a> 				<strong class="jxr_keyword">for</strong> (Parameter p : ((Behavior) name.getId()).getOwnedParameters()) {
<a class="jxr_linenumber" name="L401" href="#L401">401</a> 					<strong class="jxr_keyword">if</strong> (p.getDirection() == ParameterDirectionKind.RETURN_LITERAL) {
<a class="jxr_linenumber" name="L402" href="#L402">402</a> 						<strong class="jxr_keyword">return</strong> p.getType();
<a class="jxr_linenumber" name="L403" href="#L403">403</a> 					}
<a class="jxr_linenumber" name="L404" href="#L404">404</a> 				}
<a class="jxr_linenumber" name="L405" href="#L405">405</a> 			}
<a class="jxr_linenumber" name="L406" href="#L406">406</a> 			<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L407" href="#L407">407</a> 		}
<a class="jxr_linenumber" name="L408" href="#L408">408</a> 		<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L409" href="#L409">409</a> 	}
<a class="jxr_linenumber" name="L410" href="#L410">410</a> 
<a class="jxr_linenumber" name="L411" href="#L411">411</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L412" href="#L412">412</a> <em class="jxr_javadoccomment">	 * @param timeExpression</em>
<a class="jxr_linenumber" name="L413" href="#L413">413</a> <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L414" href="#L414">414</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L415" href="#L415">415</a> 	<strong class="jxr_keyword">private</strong> Type typeOfTimeExpression(TimeExpression timeExpression) {
<a class="jxr_linenumber" name="L416" href="#L416">416</a> 		<strong class="jxr_keyword">if</strong> (timeExpression instanceof InstantObsExpression) {
<a class="jxr_linenumber" name="L417" href="#L417">417</a> 			<strong class="jxr_keyword">return</strong> VSLJavaValidator._datetime;
<a class="jxr_linenumber" name="L418" href="#L418">418</a> 		} <strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (timeExpression instanceof DurationObsExpression) {
<a class="jxr_linenumber" name="L419" href="#L419">419</a> 			<strong class="jxr_keyword">return</strong> VSLJavaValidator._real;
<a class="jxr_linenumber" name="L420" href="#L420">420</a> 		} <strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (timeExpression instanceof JitterExp) {
<a class="jxr_linenumber" name="L421" href="#L421">421</a> 			<strong class="jxr_keyword">return</strong> VSLJavaValidator._real;
<a class="jxr_linenumber" name="L422" href="#L422">422</a> 		} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L423" href="#L423">423</a> 			<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L424" href="#L424">424</a> 		}
<a class="jxr_linenumber" name="L425" href="#L425">425</a> 	}
<a class="jxr_linenumber" name="L426" href="#L426">426</a> 
<a class="jxr_linenumber" name="L427" href="#L427">427</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L428" href="#L428">428</a> <em class="jxr_javadoccomment">	 * @param variableDeclaration</em>
<a class="jxr_linenumber" name="L429" href="#L429">429</a> <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L430" href="#L430">430</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L431" href="#L431">431</a> 	<strong class="jxr_keyword">private</strong> Type typeOfVariableDeclaration(VariableDeclaration variableDeclaration) {
<a class="jxr_linenumber" name="L432" href="#L432">432</a> 		<strong class="jxr_keyword">if</strong> (variableDeclaration.getType() != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L433" href="#L433">433</a> 			<strong class="jxr_keyword">return</strong> variableDeclaration.getType().getType();
<a class="jxr_linenumber" name="L434" href="#L434">434</a> 		} <strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (variableDeclaration.getInitValue() != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L435" href="#L435">435</a> 			<strong class="jxr_keyword">return</strong> typeOfExpression(variableDeclaration.getInitValue());
<a class="jxr_linenumber" name="L436" href="#L436">436</a> 		}
<a class="jxr_linenumber" name="L437" href="#L437">437</a> 		<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L438" href="#L438">438</a> 	}
<a class="jxr_linenumber" name="L439" href="#L439">439</a> 
<a class="jxr_linenumber" name="L440" href="#L440">440</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L441" href="#L441">441</a> <em class="jxr_javadoccomment">	 * @param choice</em>
<a class="jxr_linenumber" name="L442" href="#L442">442</a> <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L443" href="#L443">443</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L444" href="#L444">444</a> 	<em class="jxr_comment">// private Type typeOfChoice (Choice choice) {</em>
<a class="jxr_linenumber" name="L445" href="#L445">445</a> 	<em class="jxr_comment">// if (choice.getChosenAlternative() != null)</em>
<a class="jxr_linenumber" name="L446" href="#L446">446</a> 	<em class="jxr_comment">// return (Type)choice.getChosenAlternative().getNamespace() ;</em>
<a class="jxr_linenumber" name="L447" href="#L447">447</a> 	<em class="jxr_comment">// return null ;</em>
<a class="jxr_linenumber" name="L448" href="#L448">448</a> 	<em class="jxr_comment">// }</em>
<a class="jxr_linenumber" name="L449" href="#L449">449</a> 
<a class="jxr_linenumber" name="L450" href="#L450">450</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L451" href="#L451">451</a> <em class="jxr_javadoccomment">	 * @param interval</em>
<a class="jxr_linenumber" name="L452" href="#L452">452</a> <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L453" href="#L453">453</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L454" href="#L454">454</a> 	<strong class="jxr_keyword">private</strong> Type typeOfInterval(Interval interval) { <em class="jxr_comment">// TODO: Works only for a depth-level of one</em>
<a class="jxr_linenumber" name="L455" href="#L455">455</a> 
<a class="jxr_linenumber" name="L456" href="#L456">456</a> 		<strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../org/eclipse/papyrus/marte/vsl/extensions/VSLTypeInferenceUtil.html">IntervalTypeProposal</a> {
<a class="jxr_linenumber" name="L457" href="#L457">457</a> 
<a class="jxr_linenumber" name="L458" href="#L458">458</a> 			<strong class="jxr_keyword">private</strong> Type boundsType = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L459" href="#L459">459</a> 
<a class="jxr_linenumber" name="L460" href="#L460">460</a> 			<strong class="jxr_keyword">public</strong> <a href="../../../../../../org/eclipse/papyrus/marte/vsl/extensions/VSLTypeInferenceUtil.html">IntervalTypeProposal</a>(Interval interval) {
<a class="jxr_linenumber" name="L461" href="#L461">461</a> 				Type typeOfLower;
<a class="jxr_linenumber" name="L462" href="#L462">462</a> 				Type typeOfUpper;
<a class="jxr_linenumber" name="L463" href="#L463">463</a> 				VSLTypeInferenceUtil localTypeChecker = self;
<a class="jxr_linenumber" name="L464" href="#L464">464</a> 				<strong class="jxr_keyword">if</strong> (expectedType.getAppliedStereotype(<span class="jxr_string">"MARTE::MARTE_Annexes::VSL::DataTypes::IntervalType"</span>) != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L465" href="#L465">465</a> 					Type expectedBoundType;
<a class="jxr_linenumber" name="L466" href="#L466">466</a> 					Stereotype intervalStereotype = expectedType.
<a class="jxr_linenumber" name="L467" href="#L467">467</a> 							getAppliedStereotype(<span class="jxr_string">"MARTE::MARTE_Annexes::VSL::DataTypes::IntervalType"</span>);
<a class="jxr_linenumber" name="L468" href="#L468">468</a> 					EObject stereotypeApplication = expectedType.getStereotypeApplication(intervalStereotype);
<a class="jxr_linenumber" name="L469" href="#L469">469</a> 					EStructuralFeature intervalAttrib = stereotypeApplication.eClass().getEStructuralFeature(<span class="jxr_string">"intervalAttrib"</span>);
<a class="jxr_linenumber" name="L470" href="#L470">470</a> 					Property intervalProperty = (Property) stereotypeApplication.eGet(intervalAttrib);
<a class="jxr_linenumber" name="L471" href="#L471">471</a> 					expectedBoundType = intervalProperty.getType();
<a class="jxr_linenumber" name="L472" href="#L472">472</a> 					<strong class="jxr_keyword">if</strong> (expectedBoundType.getAppliedStereotype(<span class="jxr_string">"MARTE::MARTE_Annexes::VSL::DataTypes::TupleType"</span>) != <strong class="jxr_keyword">null</strong> ||
<a class="jxr_linenumber" name="L473" href="#L473">473</a> 							expectedBoundType.getAppliedStereotype(<span class="jxr_string">"MARTE::MARTE_Foundations::NFPs::NfpType"</span>) != <strong class="jxr_keyword">null</strong> ||
<a class="jxr_linenumber" name="L474" href="#L474">474</a> 							expectedBoundType.getAppliedStereotype(<span class="jxr_string">"MARTE::MARTE_Annexes::VSL::DataTypes::CollectionType"</span>) != <strong class="jxr_keyword">null</strong> ||
<a class="jxr_linenumber" name="L475" href="#L475">475</a> 							expectedBoundType.getAppliedStereotype(<span class="jxr_string">"MARTE::MARTE_Annexes::VSL::DataTypes::IntervalType"</span>) != <strong class="jxr_keyword">null</strong> ||
<a class="jxr_linenumber" name="L476" href="#L476">476</a> 							expectedBoundType.getAppliedStereotype(<span class="jxr_string">"MARTE::MARTE_Annexes::VSL::DataTypes::ChoiceType"</span>) != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L477" href="#L477">477</a> 						localTypeChecker = <strong class="jxr_keyword">new</strong> <a href="../../../../../../org/eclipse/papyrus/marte/vsl/extensions/VSLTypeInferenceUtil.html">VSLTypeInferenceUtil</a>(expectedBoundType);
<a class="jxr_linenumber" name="L478" href="#L478">478</a> 					}
<a class="jxr_linenumber" name="L479" href="#L479">479</a> 				}
<a class="jxr_linenumber" name="L480" href="#L480">480</a> 				<strong class="jxr_keyword">if</strong> (interval.getLower() != <strong class="jxr_keyword">null</strong> &amp;&amp; interval.getUpper() != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L481" href="#L481">481</a> 					typeOfLower = localTypeChecker.typeOfExpression(interval.getLower());
<a class="jxr_linenumber" name="L482" href="#L482">482</a> 					typeOfUpper = localTypeChecker.typeOfExpression(interval.getUpper());
<a class="jxr_linenumber" name="L483" href="#L483">483</a> 					<strong class="jxr_keyword">if</strong> (typeOfLower != <strong class="jxr_keyword">null</strong> &amp;&amp; typeOfUpper != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L484" href="#L484">484</a> 						<strong class="jxr_keyword">if</strong> (areTypesCompatible(typeOfLower, typeOfUpper) || areTypesCompatible(typeOfUpper, typeOfLower)) {
<a class="jxr_linenumber" name="L485" href="#L485">485</a> 							<strong class="jxr_keyword">if</strong> (areTypesCompatible(typeOfLower, typeOfUpper)) {
<a class="jxr_linenumber" name="L486" href="#L486">486</a> 								<strong class="jxr_keyword">this</strong>.boundsType = typeOfUpper;
<a class="jxr_linenumber" name="L487" href="#L487">487</a> 							} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L488" href="#L488">488</a> 								<strong class="jxr_keyword">this</strong>.boundsType = typeOfLower;
<a class="jxr_linenumber" name="L489" href="#L489">489</a> 							}
<a class="jxr_linenumber" name="L490" href="#L490">490</a> 						}
<a class="jxr_linenumber" name="L491" href="#L491">491</a> 					}
<a class="jxr_linenumber" name="L492" href="#L492">492</a> 				}
<a class="jxr_linenumber" name="L493" href="#L493">493</a> 			}
<a class="jxr_linenumber" name="L494" href="#L494">494</a> 
<a class="jxr_linenumber" name="L495" href="#L495">495</a> 			<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">boolean</strong> matchesExpectedType(Type expectedType) {
<a class="jxr_linenumber" name="L496" href="#L496">496</a> 				<strong class="jxr_keyword">if</strong> (<strong class="jxr_keyword">this</strong>.boundsType == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L497" href="#L497">497</a> 					<strong class="jxr_keyword">return</strong> false;
<a class="jxr_linenumber" name="L498" href="#L498">498</a> 				}
<a class="jxr_linenumber" name="L499" href="#L499">499</a> 
<a class="jxr_linenumber" name="L500" href="#L500">500</a> 				Stereotype intervalStereotype = expectedType.
<a class="jxr_linenumber" name="L501" href="#L501">501</a> 						getAppliedStereotype(<span class="jxr_string">"MARTE::MARTE_Annexes::VSL::DataTypes::IntervalType"</span>);
<a class="jxr_linenumber" name="L502" href="#L502">502</a> 				<strong class="jxr_keyword">if</strong> (intervalStereotype != <strong class="jxr_keyword">null</strong>) { <em class="jxr_comment">// i.e. the expected type is indeed an IntervalType</em>
<a class="jxr_linenumber" name="L503" href="#L503">503</a> 					EObject stereotypeApplication = expectedType.getStereotypeApplication(intervalStereotype);
<a class="jxr_linenumber" name="L504" href="#L504">504</a> 					EStructuralFeature intervalAttrib = stereotypeApplication.eClass().getEStructuralFeature(<span class="jxr_string">"intervalAttrib"</span>);
<a class="jxr_linenumber" name="L505" href="#L505">505</a> 					Property intervalProperty = (Property) stereotypeApplication.eGet(intervalAttrib);
<a class="jxr_linenumber" name="L506" href="#L506">506</a> 					<strong class="jxr_keyword">if</strong> (areTypesCompatible(boundsType, intervalProperty.getType())) {
<a class="jxr_linenumber" name="L507" href="#L507">507</a> 						<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L508" href="#L508">508</a> 					}
<a class="jxr_linenumber" name="L509" href="#L509">509</a> 				}
<a class="jxr_linenumber" name="L510" href="#L510">510</a> 				<strong class="jxr_keyword">return</strong> false;
<a class="jxr_linenumber" name="L511" href="#L511">511</a> 			}
<a class="jxr_linenumber" name="L512" href="#L512">512</a> 
<a class="jxr_linenumber" name="L513" href="#L513">513</a> 			<strong class="jxr_keyword">public</strong> Type makeTypeProsal() {
<a class="jxr_linenumber" name="L514" href="#L514">514</a> 				<em class="jxr_comment">// TODO: to be implemented</em>
<a class="jxr_linenumber" name="L515" href="#L515">515</a> 				<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L516" href="#L516">516</a> 			}
<a class="jxr_linenumber" name="L517" href="#L517">517</a> 		}
<a class="jxr_linenumber" name="L518" href="#L518">518</a> 
<a class="jxr_linenumber" name="L519" href="#L519">519</a> 		IntervalTypeProposal proposal = <strong class="jxr_keyword">new</strong> <a href="../../../../../../org/eclipse/papyrus/marte/vsl/extensions/VSLTypeInferenceUtil.html">IntervalTypeProposal</a>(interval);
<a class="jxr_linenumber" name="L520" href="#L520">520</a> 		<strong class="jxr_keyword">if</strong> (proposal.matchesExpectedType(expectedType)) {
<a class="jxr_linenumber" name="L521" href="#L521">521</a> 			<strong class="jxr_keyword">return</strong> expectedType;
<a class="jxr_linenumber" name="L522" href="#L522">522</a> 		} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L523" href="#L523">523</a> 			<strong class="jxr_keyword">return</strong> proposal.makeTypeProsal();
<a class="jxr_linenumber" name="L524" href="#L524">524</a> 		}
<a class="jxr_linenumber" name="L525" href="#L525">525</a> 	}
<a class="jxr_linenumber" name="L526" href="#L526">526</a> 
<a class="jxr_linenumber" name="L527" href="#L527">527</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L528" href="#L528">528</a> <em class="jxr_javadoccomment">	 * @param tuple</em>
<a class="jxr_linenumber" name="L529" href="#L529">529</a> <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L530" href="#L530">530</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L531" href="#L531">531</a> 	<strong class="jxr_keyword">private</strong> Type typeOfTuple(Tuple tuple) { <em class="jxr_comment">// TODO: Works only for a depth-level of one</em>
<a class="jxr_linenumber" name="L532" href="#L532">532</a> 
<a class="jxr_linenumber" name="L533" href="#L533">533</a> 		<strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../org/eclipse/papyrus/marte/vsl/extensions/VSLTypeInferenceUtil.html">TupleTypeProposal</a> {
<a class="jxr_linenumber" name="L534" href="#L534">534</a> 
<a class="jxr_linenumber" name="L535" href="#L535">535</a> 			<strong class="jxr_keyword">private</strong> List&lt;Property&gt; tupleAttribs = <strong class="jxr_keyword">new</strong> ArrayList&lt;Property&gt;();
<a class="jxr_linenumber" name="L536" href="#L536">536</a> 
<a class="jxr_linenumber" name="L537" href="#L537">537</a> 			<strong class="jxr_keyword">public</strong> <a href="../../../../../../org/eclipse/papyrus/marte/vsl/extensions/VSLTypeInferenceUtil.html">TupleTypeProposal</a>(Tuple tuple) {
<a class="jxr_linenumber" name="L538" href="#L538">538</a> 				<strong class="jxr_keyword">for</strong> (ValueNamePair v : tuple.getListOfValueNamePairs().getValueNamePairs()) {
<a class="jxr_linenumber" name="L539" href="#L539">539</a> 					<strong class="jxr_keyword">if</strong> (v.getProperty() != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L540" href="#L540">540</a> 						tupleAttribs.add(v.getProperty());
<a class="jxr_linenumber" name="L541" href="#L541">541</a> 					}
<a class="jxr_linenumber" name="L542" href="#L542">542</a> 				}
<a class="jxr_linenumber" name="L543" href="#L543">543</a> 			}
<a class="jxr_linenumber" name="L544" href="#L544">544</a> 
<a class="jxr_linenumber" name="L545" href="#L545">545</a> 			<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">boolean</strong> matchesExpectedType(Type expectedType) {
<a class="jxr_linenumber" name="L546" href="#L546">546</a> 				Stereotype tupleStereotype = expectedType.
<a class="jxr_linenumber" name="L547" href="#L547">547</a> 						getAppliedStereotype(<span class="jxr_string">"MARTE::MARTE_Annexes::VSL::DataTypes::TupleType"</span>);
<a class="jxr_linenumber" name="L548" href="#L548">548</a> 				<strong class="jxr_keyword">if</strong> (tupleStereotype == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L549" href="#L549">549</a> 					tupleStereotype = expectedType.
<a class="jxr_linenumber" name="L550" href="#L550">550</a> 							getAppliedStereotype(<span class="jxr_string">"MARTE::MARTE_Foundations::NFPs::NfpType"</span>);
<a class="jxr_linenumber" name="L551" href="#L551">551</a> 				}
<a class="jxr_linenumber" name="L552" href="#L552">552</a> 				<strong class="jxr_keyword">if</strong> (tupleStereotype != <strong class="jxr_keyword">null</strong>) { <em class="jxr_comment">// i.e. the expected type is indeed a TupleType</em>
<a class="jxr_linenumber" name="L553" href="#L553">553</a> 					EObject stereotypeApplication = expectedType.getStereotypeApplication(tupleStereotype);
<a class="jxr_linenumber" name="L554" href="#L554">554</a> 					EStructuralFeature tupleAttrib = stereotypeApplication.eClass().getEStructuralFeature(<span class="jxr_string">"tupleAttrib"</span>);
<a class="jxr_linenumber" name="L555" href="#L555">555</a> 					List&lt;Property&gt; tupleProperty = (List&lt;Property&gt;) stereotypeApplication.eGet(tupleAttrib);
<a class="jxr_linenumber" name="L556" href="#L556">556</a> 					<strong class="jxr_keyword">if</strong> (tupleProperty.isEmpty()) {
<a class="jxr_linenumber" name="L557" href="#L557">557</a> 						<strong class="jxr_keyword">return</strong> ((DataType) expectedType).getAllAttributes().containsAll(tupleAttribs);
<a class="jxr_linenumber" name="L558" href="#L558">558</a> 					} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L559" href="#L559">559</a> 						<strong class="jxr_keyword">return</strong> tupleProperty.containsAll(tupleAttribs);
<a class="jxr_linenumber" name="L560" href="#L560">560</a> 					}
<a class="jxr_linenumber" name="L561" href="#L561">561</a> 				}
<a class="jxr_linenumber" name="L562" href="#L562">562</a> 				<em class="jxr_comment">// TODO: Handle the case where the tuple syntax is used for fixing a value for a default chosen alternative in a choice</em>
<a class="jxr_linenumber" name="L563" href="#L563">563</a> 				<strong class="jxr_keyword">return</strong> false;
<a class="jxr_linenumber" name="L564" href="#L564">564</a> 			}
<a class="jxr_linenumber" name="L565" href="#L565">565</a> 
<a class="jxr_linenumber" name="L566" href="#L566">566</a> 			<strong class="jxr_keyword">public</strong> Type makeTypeProposal() {
<a class="jxr_linenumber" name="L567" href="#L567">567</a> 				<em class="jxr_comment">// TODO: To be implemented</em>
<a class="jxr_linenumber" name="L568" href="#L568">568</a> 				<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L569" href="#L569">569</a> 			}
<a class="jxr_linenumber" name="L570" href="#L570">570</a> 		}
<a class="jxr_linenumber" name="L571" href="#L571">571</a> 
<a class="jxr_linenumber" name="L572" href="#L572">572</a> 		TupleTypeProposal proposal = <strong class="jxr_keyword">new</strong> <a href="../../../../../../org/eclipse/papyrus/marte/vsl/extensions/VSLTypeInferenceUtil.html">TupleTypeProposal</a>(tuple);
<a class="jxr_linenumber" name="L573" href="#L573">573</a> 		<strong class="jxr_keyword">if</strong> (proposal.matchesExpectedType(expectedType)) {
<a class="jxr_linenumber" name="L574" href="#L574">574</a> 			<strong class="jxr_keyword">return</strong> expectedType;
<a class="jxr_linenumber" name="L575" href="#L575">575</a> 		} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L576" href="#L576">576</a> 			<strong class="jxr_keyword">return</strong> proposal.makeTypeProposal();
<a class="jxr_linenumber" name="L577" href="#L577">577</a> 		}
<a class="jxr_linenumber" name="L578" href="#L578">578</a> 	}
<a class="jxr_linenumber" name="L579" href="#L579">579</a> 
<a class="jxr_linenumber" name="L580" href="#L580">580</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L581" href="#L581">581</a> <em class="jxr_javadoccomment">	 * @param collOrtuple</em>
<a class="jxr_linenumber" name="L582" href="#L582">582</a> <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L583" href="#L583">583</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L584" href="#L584">584</a> 	<strong class="jxr_keyword">private</strong> Type typeOfCollectionOrTuple(CollectionOrTuple collOrtuple) { <em class="jxr_comment">// TODO : Works only for a depth-level of one</em>
<a class="jxr_linenumber" name="L585" href="#L585">585</a> 
<a class="jxr_linenumber" name="L586" href="#L586">586</a> 		<strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../org/eclipse/papyrus/marte/vsl/extensions/VSLTypeInferenceUtil.html">CollectionOrTupleTypeProposal</a> {
<a class="jxr_linenumber" name="L587" href="#L587">587</a> 
<a class="jxr_linenumber" name="L588" href="#L588">588</a> 			<strong class="jxr_keyword">private</strong> List&lt;Type&gt; collectionOrTupleElemTypes = <strong class="jxr_keyword">new</strong> ArrayList&lt;Type&gt;();
<a class="jxr_linenumber" name="L589" href="#L589">589</a> 
<a class="jxr_linenumber" name="L590" href="#L590">590</a> 			<strong class="jxr_keyword">public</strong> <a href="../../../../../../org/eclipse/papyrus/marte/vsl/extensions/VSLTypeInferenceUtil.html">CollectionOrTupleTypeProposal</a>(CollectionOrTuple collOrTuple) {
<a class="jxr_linenumber" name="L591" href="#L591">591</a> 				VSLTypeInferenceUtil localTypeChecker = self;
<a class="jxr_linenumber" name="L592" href="#L592">592</a> 				List&lt;VSLTypeInferenceUtil&gt; localListOfTypeCheckers = <strong class="jxr_keyword">new</strong> ArrayList&lt;VSLTypeInferenceUtil&gt;();
<a class="jxr_linenumber" name="L593" href="#L593">593</a> 				<strong class="jxr_keyword">if</strong> (expectedType.getAppliedStereotype(<span class="jxr_string">"MARTE::MARTE_Annexes::VSL::DataTypes::CollectionType"</span>) != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L594" href="#L594">594</a> 					Type expectedElementType;
<a class="jxr_linenumber" name="L595" href="#L595">595</a> 					Stereotype collectionStereotype = expectedType.
<a class="jxr_linenumber" name="L596" href="#L596">596</a> 							getAppliedStereotype(<span class="jxr_string">"MARTE::MARTE_Annexes::VSL::DataTypes::CollectionType"</span>);
<a class="jxr_linenumber" name="L597" href="#L597">597</a> 					EObject stereotypeApplication = expectedType.getStereotypeApplication(collectionStereotype);
<a class="jxr_linenumber" name="L598" href="#L598">598</a> 					EStructuralFeature collectionAttrib = stereotypeApplication.eClass().getEStructuralFeature(<span class="jxr_string">"collectionAttrib"</span>);
<a class="jxr_linenumber" name="L599" href="#L599">599</a> 					Property collectionProperty = (Property) stereotypeApplication.eGet(collectionAttrib);
<a class="jxr_linenumber" name="L600" href="#L600">600</a> 					expectedElementType = collectionProperty.getType();
<a class="jxr_linenumber" name="L601" href="#L601">601</a> 					<strong class="jxr_keyword">if</strong> (expectedElementType.getAppliedStereotype(<span class="jxr_string">"MARTE::MARTE_Annexes::VSL::DataTypes::TupleType"</span>) != <strong class="jxr_keyword">null</strong> ||
<a class="jxr_linenumber" name="L602" href="#L602">602</a> 							expectedElementType.getAppliedStereotype(<span class="jxr_string">"MARTE::MARTE_Foundations::NFPs::NfpType"</span>) != <strong class="jxr_keyword">null</strong> ||
<a class="jxr_linenumber" name="L603" href="#L603">603</a> 							expectedElementType.getAppliedStereotype(<span class="jxr_string">"MARTE::MARTE_Annexes::VSL::DataTypes::CollectionType"</span>) != <strong class="jxr_keyword">null</strong> ||
<a class="jxr_linenumber" name="L604" href="#L604">604</a> 							expectedElementType.getAppliedStereotype(<span class="jxr_string">"MARTE::MARTE_Annexes::VSL::DataTypes::IntervalType"</span>) != <strong class="jxr_keyword">null</strong> ||
<a class="jxr_linenumber" name="L605" href="#L605">605</a> 							expectedElementType.getAppliedStereotype(<span class="jxr_string">"MARTE::MARTE_Annexes::VSL::DataTypes::ChoiceType"</span>) != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L606" href="#L606">606</a> 						localTypeChecker = <strong class="jxr_keyword">new</strong> <a href="../../../../../../org/eclipse/papyrus/marte/vsl/extensions/VSLTypeInferenceUtil.html">VSLTypeInferenceUtil</a>(expectedElementType);
<a class="jxr_linenumber" name="L607" href="#L607">607</a> 					}
<a class="jxr_linenumber" name="L608" href="#L608">608</a> 				}
<a class="jxr_linenumber" name="L609" href="#L609">609</a> 				<strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (expectedType.getAppliedStereotype(<span class="jxr_string">"MARTE::MARTE_Annexes::VSL::DataTypes::TupleType"</span>) != <strong class="jxr_keyword">null</strong> ||
<a class="jxr_linenumber" name="L610" href="#L610">610</a> 						expectedType.getAppliedStereotype(<span class="jxr_string">"MARTE::MARTE_Foundations::NFPs::NfpType"</span>) != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L611" href="#L611">611</a> 					<em class="jxr_comment">// Stereotype tupleStereotype = expectedType.</em>
<a class="jxr_linenumber" name="L612" href="#L612">612</a> 					<em class="jxr_comment">// getAppliedStereotype("MARTE::MARTE_Annexes::VSL::DataTypes::TupleType") ;</em>
<a class="jxr_linenumber" name="L613" href="#L613">613</a> 					<em class="jxr_comment">// EObject stereotypeApplication = expectedType.getStereotypeApplication(tupleStereotype) ;</em>
<a class="jxr_linenumber" name="L614" href="#L614">614</a> 					<em class="jxr_comment">// EStructuralFeature tupleAttrib = stereotypeApplication.eClass().getEStructuralFeature("tupleAttrib") ;</em>
<a class="jxr_linenumber" name="L615" href="#L615">615</a> 					<em class="jxr_comment">// List&lt;Property&gt; collectionProperty = (List&lt;Property&gt;) stereotypeApplication.eGet(tupleAttrib) ;</em>
<a class="jxr_linenumber" name="L616" href="#L616">616</a> 					List&lt;Property&gt; collectionProperty = <strong class="jxr_keyword">new</strong> ArrayList&lt;Property&gt;();
<a class="jxr_linenumber" name="L617" href="#L617">617</a> 					collectionProperty.addAll(((Classifier) expectedType).getAllAttributes());
<a class="jxr_linenumber" name="L618" href="#L618">618</a> 					<strong class="jxr_keyword">if</strong> (collectionProperty.isEmpty()) {
<a class="jxr_linenumber" name="L619" href="#L619">619</a> 						collectionProperty = ((Classifier) expectedType).getAllAttributes();
<a class="jxr_linenumber" name="L620" href="#L620">620</a> 					}
<a class="jxr_linenumber" name="L621" href="#L621">621</a> 					<strong class="jxr_keyword">for</strong> (<strong class="jxr_keyword">int</strong> i = 0; i &lt; collOrTuple.getListOfValues().getValues().size(); i++) {
<a class="jxr_linenumber" name="L622" href="#L622">622</a> 						Type expectedElementType;
<a class="jxr_linenumber" name="L623" href="#L623">623</a> 						expectedElementType = i &lt; collectionProperty.size() ? collectionProperty.get(i).getType() : <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L624" href="#L624">624</a> 						<strong class="jxr_keyword">if</strong> (expectedElementType != <strong class="jxr_keyword">null</strong> &amp;&amp;
<a class="jxr_linenumber" name="L625" href="#L625">625</a> 								(expectedElementType.getAppliedStereotype(<span class="jxr_string">"MARTE::MARTE_Annexes::VSL::DataTypes::TupleType"</span>) != <strong class="jxr_keyword">null</strong> ||
<a class="jxr_linenumber" name="L626" href="#L626">626</a> 										expectedElementType.getAppliedStereotype(<span class="jxr_string">"MARTE::MARTE_Foundations::NFPs::NfpType"</span>) != <strong class="jxr_keyword">null</strong> ||
<a class="jxr_linenumber" name="L627" href="#L627">627</a> 										expectedElementType.getAppliedStereotype(<span class="jxr_string">"MARTE::MARTE_Annexes::VSL::DataTypes::CollectionType"</span>) != <strong class="jxr_keyword">null</strong> ||
<a class="jxr_linenumber" name="L628" href="#L628">628</a> 										expectedElementType.getAppliedStereotype(<span class="jxr_string">"MARTE::MARTE_Annexes::VSL::DataTypes::IntervalType"</span>) != <strong class="jxr_keyword">null</strong> ||
<a class="jxr_linenumber" name="L629" href="#L629">629</a> 								expectedElementType.getAppliedStereotype(<span class="jxr_string">"MARTE::MARTE_Annexes::VSL::DataTypes::ChoiceType"</span>) != <strong class="jxr_keyword">null</strong>)) {
<a class="jxr_linenumber" name="L630" href="#L630">630</a> 							localListOfTypeCheckers.add(<strong class="jxr_keyword">new</strong> <a href="../../../../../../org/eclipse/papyrus/marte/vsl/extensions/VSLTypeInferenceUtil.html">VSLTypeInferenceUtil</a>(expectedElementType));
<a class="jxr_linenumber" name="L631" href="#L631">631</a> 						} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L632" href="#L632">632</a> 							localListOfTypeCheckers.add(self);
<a class="jxr_linenumber" name="L633" href="#L633">633</a> 						}
<a class="jxr_linenumber" name="L634" href="#L634">634</a> 					}
<a class="jxr_linenumber" name="L635" href="#L635">635</a> 				}
<a class="jxr_linenumber" name="L636" href="#L636">636</a> 				<strong class="jxr_keyword">for</strong> (<strong class="jxr_keyword">int</strong> i = 0; i &lt; collOrTuple.getListOfValues().getValues().size(); i++) {
<a class="jxr_linenumber" name="L637" href="#L637">637</a> 					Expression exp = collOrTuple.getListOfValues().getValues().get(i);
<a class="jxr_linenumber" name="L638" href="#L638">638</a> 					Type typeOfExp = ((expectedType.getAppliedStereotype(<span class="jxr_string">"MARTE::MARTE_Annexes::VSL::DataTypes::TupleType"</span>) != <strong class="jxr_keyword">null</strong> ||
<a class="jxr_linenumber" name="L639" href="#L639">639</a> 							expectedType.getAppliedStereotype(<span class="jxr_string">"MARTE::MARTE_Foundations::NFPs::NfpType"</span>) != <strong class="jxr_keyword">null</strong>)
<a class="jxr_linenumber" name="L640" href="#L640">640</a> 									? localListOfTypeCheckers.get(i) : localTypeChecker).typeOfExpression(exp);
<a class="jxr_linenumber" name="L641" href="#L641">641</a> 					<em class="jxr_comment">// if (typeOfExp != null)</em>
<a class="jxr_linenumber" name="L642" href="#L642">642</a> 					collectionOrTupleElemTypes.add(typeOfExp);
<a class="jxr_linenumber" name="L643" href="#L643">643</a> 				}
<a class="jxr_linenumber" name="L644" href="#L644">644</a> 			}
<a class="jxr_linenumber" name="L645" href="#L645">645</a> 
<a class="jxr_linenumber" name="L646" href="#L646">646</a> 			<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">boolean</strong> matchesExpectedType(Type expectedType) {
<a class="jxr_linenumber" name="L647" href="#L647">647</a> 				Stereotype tupleStereotype = expectedType.
<a class="jxr_linenumber" name="L648" href="#L648">648</a> 						getAppliedStereotype(<span class="jxr_string">"MARTE::MARTE_Annexes::VSL::DataTypes::TupleType"</span>);
<a class="jxr_linenumber" name="L649" href="#L649">649</a> 				tupleStereotype = expectedType.getAppliedStereotype(<span class="jxr_string">"MARTE::MARTE_Foundations::NFPs::NfpType"</span>);
<a class="jxr_linenumber" name="L650" href="#L650">650</a> 				Stereotype collectionStereotype = expectedType.
<a class="jxr_linenumber" name="L651" href="#L651">651</a> 						getAppliedStereotype(<span class="jxr_string">"MARTE::MARTE_Annexes::VSL::DataTypes::CollectionType"</span>);
<a class="jxr_linenumber" name="L652" href="#L652">652</a> 				<strong class="jxr_keyword">if</strong> (collectionStereotype != <strong class="jxr_keyword">null</strong>) { <em class="jxr_comment">// i.e. the expected type is indeed a CollectionType</em>
<a class="jxr_linenumber" name="L653" href="#L653">653</a> 					<em class="jxr_comment">// there must be one distinguishable type in collectionOrTupleElemTypes</em>
<a class="jxr_linenumber" name="L654" href="#L654">654</a> 					<em class="jxr_comment">// and it must conform to the type of the collectionAttrib</em>
<a class="jxr_linenumber" name="L655" href="#L655">655</a> 					EObject stereotypeApplication = expectedType.getStereotypeApplication(collectionStereotype);
<a class="jxr_linenumber" name="L656" href="#L656">656</a> 					EStructuralFeature collectionAttrib = stereotypeApplication.eClass().getEStructuralFeature(<span class="jxr_string">"collectionAttrib"</span>);
<a class="jxr_linenumber" name="L657" href="#L657">657</a> 					Property collectionProperty = (Property) stereotypeApplication.eGet(collectionAttrib);
<a class="jxr_linenumber" name="L658" href="#L658">658</a> 					<strong class="jxr_keyword">if</strong> (collectionProperty.getType() != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L659" href="#L659">659</a> 						<em class="jxr_comment">// collectionOrTupleElemTypes must not be empty</em>
<a class="jxr_linenumber" name="L660" href="#L660">660</a> 						<em class="jxr_comment">// and each of its types must conform to collectionProperty.getType</em>
<a class="jxr_linenumber" name="L661" href="#L661">661</a> 						<strong class="jxr_keyword">if</strong> (collectionOrTupleElemTypes.isEmpty()) {
<a class="jxr_linenumber" name="L662" href="#L662">662</a> 							<strong class="jxr_keyword">return</strong> false;
<a class="jxr_linenumber" name="L663" href="#L663">663</a> 						}
<a class="jxr_linenumber" name="L664" href="#L664">664</a> 						<strong class="jxr_keyword">for</strong> (Type t : collectionOrTupleElemTypes) {
<a class="jxr_linenumber" name="L665" href="#L665">665</a> 							<strong class="jxr_keyword">if</strong> (!areTypesCompatible(t, collectionProperty.getType())) {
<a class="jxr_linenumber" name="L666" href="#L666">666</a> 								<strong class="jxr_keyword">return</strong> false;
<a class="jxr_linenumber" name="L667" href="#L667">667</a> 							}
<a class="jxr_linenumber" name="L668" href="#L668">668</a> 						}
<a class="jxr_linenumber" name="L669" href="#L669">669</a> 						<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L670" href="#L670">670</a> 					}
<a class="jxr_linenumber" name="L671" href="#L671">671</a> 				}
<a class="jxr_linenumber" name="L672" href="#L672">672</a> 				<strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (tupleStereotype != <strong class="jxr_keyword">null</strong>) { <em class="jxr_comment">// i.e. the expected type is indeed a TupleType</em>
<a class="jxr_linenumber" name="L673" href="#L673">673</a> 					<em class="jxr_comment">// EObject stereotypeApplication = expectedType.getStereotypeApplication(tupleStereotype) ;</em>
<a class="jxr_linenumber" name="L674" href="#L674">674</a> 					<em class="jxr_comment">// EStructuralFeature tupleAttrib = stereotypeApplication.eClass().getEStructuralFeature("tupleAttrib") ;</em>
<a class="jxr_linenumber" name="L675" href="#L675">675</a> 					<em class="jxr_comment">// List&lt;Property&gt; tupleProperty = (List&lt;Property&gt;) stereotypeApplication.eGet(tupleAttrib) ;</em>
<a class="jxr_linenumber" name="L676" href="#L676">676</a> 					List&lt;Property&gt; tupleProperty = <strong class="jxr_keyword">new</strong> ArrayList&lt;Property&gt;();
<a class="jxr_linenumber" name="L677" href="#L677">677</a> 					tupleProperty.addAll(((Classifier) expectedType).getAllAttributes());
<a class="jxr_linenumber" name="L678" href="#L678">678</a> 					<strong class="jxr_keyword">if</strong> (tupleProperty.isEmpty()) {
<a class="jxr_linenumber" name="L679" href="#L679">679</a> 						<strong class="jxr_keyword">int</strong> numberOfElementsToTest = Math.min(((DataType) expectedType).getAllAttributes().size(), collectionOrTupleElemTypes.size());
<a class="jxr_linenumber" name="L680" href="#L680">680</a> 						<em class="jxr_comment">// if (((DataType)expectedType).getAllAttributes().size() != collectionOrTupleElemTypes.size())</em>
<a class="jxr_linenumber" name="L681" href="#L681">681</a> 						<em class="jxr_comment">// return false ;</em>
<a class="jxr_linenumber" name="L682" href="#L682">682</a> 						<em class="jxr_comment">// else {</em>
<a class="jxr_linenumber" name="L683" href="#L683">683</a> 						<strong class="jxr_keyword">for</strong> (<strong class="jxr_keyword">int</strong> i = 0; i &lt; numberOfElementsToTest; i++) {
<a class="jxr_linenumber" name="L684" href="#L684">684</a> 							<strong class="jxr_keyword">if</strong> (collectionOrTupleElemTypes.get(i) != <strong class="jxr_keyword">null</strong> &amp;&amp;
<a class="jxr_linenumber" name="L685" href="#L685">685</a> 									((DataType) expectedType).getAllAttributes().get(i) != <strong class="jxr_keyword">null</strong> &amp;&amp;
<a class="jxr_linenumber" name="L686" href="#L686">686</a> 									((DataType) expectedType).getAllAttributes().get(i).getType() != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L687" href="#L687">687</a> 								<strong class="jxr_keyword">if</strong> (!areTypesCompatible(collectionOrTupleElemTypes.get(i), ((DataType) expectedType).getAllAttributes().get(i).getType())) {
<a class="jxr_linenumber" name="L688" href="#L688">688</a> 									<strong class="jxr_keyword">return</strong> false;
<a class="jxr_linenumber" name="L689" href="#L689">689</a> 								}
<a class="jxr_linenumber" name="L690" href="#L690">690</a> 							} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L691" href="#L691">691</a> 								<strong class="jxr_keyword">return</strong> false;
<a class="jxr_linenumber" name="L692" href="#L692">692</a> 							}
<a class="jxr_linenumber" name="L693" href="#L693">693</a> 						}
<a class="jxr_linenumber" name="L694" href="#L694">694</a> 						<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L695" href="#L695">695</a> 						<em class="jxr_comment">// }</em>
<a class="jxr_linenumber" name="L696" href="#L696">696</a> 					}
<a class="jxr_linenumber" name="L697" href="#L697">697</a> 					<strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L698" href="#L698">698</a> 						<strong class="jxr_keyword">int</strong> numberOfElementsToTest = Math.min(((DataType) expectedType).getAllAttributes().size(), collectionOrTupleElemTypes.size());
<a class="jxr_linenumber" name="L699" href="#L699">699</a> 						<em class="jxr_comment">// if (tupleProperty.size() != collectionOrTupleElemTypes.size())</em>
<a class="jxr_linenumber" name="L700" href="#L700">700</a> 						<em class="jxr_comment">// if (tupleProperty.size() &gt; collectionOrTupleElemTypes.size())</em>
<a class="jxr_linenumber" name="L701" href="#L701">701</a> 						<em class="jxr_comment">// return false ;</em>
<a class="jxr_linenumber" name="L702" href="#L702">702</a> 						<em class="jxr_comment">// else {</em>
<a class="jxr_linenumber" name="L703" href="#L703">703</a> 						<em class="jxr_comment">// for (int i = 0 ; i &lt; collectionOrTupleElemTypes.size() ; i++) {</em>
<a class="jxr_linenumber" name="L704" href="#L704">704</a> 						<strong class="jxr_keyword">for</strong> (<strong class="jxr_keyword">int</strong> i = 0; i &lt; numberOfElementsToTest; i++) {
<a class="jxr_linenumber" name="L705" href="#L705">705</a> 							<strong class="jxr_keyword">if</strong> (collectionOrTupleElemTypes.get(i) != <strong class="jxr_keyword">null</strong> &amp;&amp;
<a class="jxr_linenumber" name="L706" href="#L706">706</a> 									tupleProperty.get(i) != <strong class="jxr_keyword">null</strong> &amp;&amp;
<a class="jxr_linenumber" name="L707" href="#L707">707</a> 									tupleProperty.get(i).getType() != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L708" href="#L708">708</a> 								<strong class="jxr_keyword">if</strong> (!areTypesCompatible(collectionOrTupleElemTypes.get(i), tupleProperty.get(i).getType())) {
<a class="jxr_linenumber" name="L709" href="#L709">709</a> 									<strong class="jxr_keyword">return</strong> false;
<a class="jxr_linenumber" name="L710" href="#L710">710</a> 								}
<a class="jxr_linenumber" name="L711" href="#L711">711</a> 							} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L712" href="#L712">712</a> 								<strong class="jxr_keyword">return</strong> false;
<a class="jxr_linenumber" name="L713" href="#L713">713</a> 							}
<a class="jxr_linenumber" name="L714" href="#L714">714</a> 						}
<a class="jxr_linenumber" name="L715" href="#L715">715</a> 						<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L716" href="#L716">716</a> 						<em class="jxr_comment">// }</em>
<a class="jxr_linenumber" name="L717" href="#L717">717</a> 					}
<a class="jxr_linenumber" name="L718" href="#L718">718</a> 				}
<a class="jxr_linenumber" name="L719" href="#L719">719</a> 				<em class="jxr_comment">// TODO: Handle the case where the tuple syntax is used for fixing a value for a default chosen alternative in a choice</em>
<a class="jxr_linenumber" name="L720" href="#L720">720</a> 				<strong class="jxr_keyword">return</strong> false;
<a class="jxr_linenumber" name="L721" href="#L721">721</a> 			}
<a class="jxr_linenumber" name="L722" href="#L722">722</a> 
<a class="jxr_linenumber" name="L723" href="#L723">723</a> 			<strong class="jxr_keyword">public</strong> Type makeTypeProposal() {
<a class="jxr_linenumber" name="L724" href="#L724">724</a> 				<em class="jxr_comment">// TODO: to be implemented</em>
<a class="jxr_linenumber" name="L725" href="#L725">725</a> 				<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L726" href="#L726">726</a> 			}
<a class="jxr_linenumber" name="L727" href="#L727">727</a> 		}
<a class="jxr_linenumber" name="L728" href="#L728">728</a> 
<a class="jxr_linenumber" name="L729" href="#L729">729</a> 		CollectionOrTupleTypeProposal proposal = <strong class="jxr_keyword">new</strong> <a href="../../../../../../org/eclipse/papyrus/marte/vsl/extensions/VSLTypeInferenceUtil.html">CollectionOrTupleTypeProposal</a>(collOrtuple);
<a class="jxr_linenumber" name="L730" href="#L730">730</a> 		<strong class="jxr_keyword">if</strong> (proposal.matchesExpectedType(expectedType)) {
<a class="jxr_linenumber" name="L731" href="#L731">731</a> 			<strong class="jxr_keyword">return</strong> expectedType;
<a class="jxr_linenumber" name="L732" href="#L732">732</a> 		} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L733" href="#L733">733</a> 			<strong class="jxr_keyword">return</strong> proposal.makeTypeProposal();
<a class="jxr_linenumber" name="L734" href="#L734">734</a> 		}
<a class="jxr_linenumber" name="L735" href="#L735">735</a> 	}
<a class="jxr_linenumber" name="L736" href="#L736">736</a> 
<a class="jxr_linenumber" name="L737" href="#L737">737</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">boolean</strong> areTypesCompatible(Type found, Type expected) {
<a class="jxr_linenumber" name="L738" href="#L738">738</a> 
<a class="jxr_linenumber" name="L739" href="#L739">739</a> 		<strong class="jxr_keyword">if</strong> (found == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L740" href="#L740">740</a> 			<strong class="jxr_keyword">return</strong> false;
<a class="jxr_linenumber" name="L741" href="#L741">741</a> 		}
<a class="jxr_linenumber" name="L742" href="#L742">742</a> 
<a class="jxr_linenumber" name="L743" href="#L743">743</a> 		<strong class="jxr_keyword">if</strong> (found == VSLJavaValidator._integer &amp;&amp; expected == VSLJavaValidator._unlimitedNatural) {
<a class="jxr_linenumber" name="L744" href="#L744">744</a> 			<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L745" href="#L745">745</a> 		}
<a class="jxr_linenumber" name="L746" href="#L746">746</a> 
<a class="jxr_linenumber" name="L747" href="#L747">747</a> 		<strong class="jxr_keyword">return</strong> found.conformsTo(expected);
<a class="jxr_linenumber" name="L748" href="#L748">748</a> 	}
<a class="jxr_linenumber" name="L749" href="#L749">749</a> }
</pre>
<hr/>
<div id="footer">Copyright &#169; 2017 <a href="https://www.eclipse.org/">Eclipse foundation</a>. All rights reserved.</div>
</body>
</html>
